#!/usr/bin/env node
import{createCommand as q}from"commander";import{readdirSync as w,mkdirSync as C,statSync as D,writeFileSync as h,readFileSync as k,existsSync as W}from"node:fs";import{dirname as x,join as u,resolve as E}from"node:path";import{select as g,input as v,confirm as z}from"@inquirer/prompts";import{execaCommandSync as d,execaCommand as G}from"execa";import{fileURLToPath as j}from"node:url";const T={hope:"create-vuepress-theme-hope"},f=e=>{try{w(e)}catch{try{C(e,{recursive:!0})}catch{}}},M=(e,s)=>{const t=x(s);f(t),h(s,k(e))},N=(e,s)=>{f(s),w(e,{withFileTypes:!0}).forEach(t=>{t.isFile()?M(`${e}/${t.name}`,`${s}/${t.name}`):t.isDirectory()&&N(`${e}/${t.name}`,`${s}/${t.name}`)})},_=(e,s)=>{D(e).isDirectory()?N(e,s):D(e).isFile()&&M(e,s)},F=()=>{try{return d("pnpm --version",{stdio:"ignore"}).exitCode===0}catch{return!1}},O=()=>{try{return d("yarn --version",{stdio:"ignore"}).exitCode===0}catch{return!1}},S=["npm"];O()&&S.unshift("yarn"),F()&&S.unshift("pnpm");const A=e=>g({message:e,choices:S.map(s=>({name:s,value:s}))}),P="https://registry.npmmirror.com/",H=(e,s)=>d(`${e} config get ${s?"npmRegistryServer":"registry"}`).stdout,I=async(e,s)=>{const t=e==="yarn"&&!d("yarn --version").stdout.startsWith("1"),o=H(e,t);return/https:\/\/registry\.npm\.taobao\.org\/?/.test(o)&&(console.error("npm.taobao.org is no longer available, resetting it to npmmirror.com"),d(`${e} config set ${t?"npmRegistryServer":"registry"} ${P}`)),s==="zh"?g({message:"选择你想使用的源",choices:[{name:"国内镜像源",value:P},{name:"当前源",value:o}]}):o},y="vuepress-theme-",Y=e=>{const s=e.match(/^@(.*)\/(.*)$/);if(s===null)return e.startsWith(y)?e:`${y}${e}`;const[,t,o]=s;return t==="vuepress"?o.startsWith("theme-")?e:`@vuepress/theme-${o}`:o.startsWith(y)?e:`@${t}/${y}${o}`},J=JSON.parse(k(j(import.meta.resolve("create-vuepress/package.json")),"utf-8")),{devDependencies:m,version:R}=J,U=/^(?:@[a-z0-9-*~][a-z0-9-*._~]*\/)?[a-z0-9-~][a-z0-9-._~]*$/u,V=/^[0-9]+\.[0-9]+\.(?:[0-9]+|[0-9]+-[a-z]+\.[0-9])$/u,B=async({targetDir:e,packageManager:s,locale:t,preset:o,bundler:i})=>{const r=u(e,"package.json");console.info(t.flow.createPackage);const n=await v({message:t.question.name,default:"my-vuepress-site",validate:$=>U.exec($)?!0:t.error.name}),c=await v({message:t.question.description,default:"A VuePress project"}),a=await v({message:t.question.version,default:"0.0.1",validate:$=>V.exec($)?!0:t.error.version}),l=await v({message:t.question.license,default:"MIT"}),p={name:n,description:c,version:a,license:l,type:"module",scripts:{"docs:build":"vuepress build docs","docs:clean-dev":"vuepress dev docs --clean-cache","docs:dev":"vuepress dev docs","docs:update-package":`${s==="npm"?"npx":`${s} dlx`} vp-update`},devDependencies:{[`@vuepress/bundler-${i}`]:m.vuepress,"@vuepress/theme-default":m["@vuepress/theme-default"],"sass-embedded":m["sass-embedded"],...i==="webpack"?{"sass-loader":m["sass-loader"]}:{},vue:m.vue,vuepress:m.vuepress,...o==="blog"?{"@vuepress/plugin-blog":m["@vuepress/plugin-blog"]}:{}}};h(r,`${JSON.stringify(p,null,2)}
`,{encoding:"utf-8"})},L=u(x(j(import.meta.resolve("create-vuepress/package.json"))),"./template"),K=(e,s)=>`
name: ${s==="zh"?"部署文档":"Deploy Docs"}

on:
  push:
    branches:
      # ${s==="zh"?"确保这是你正在使用的分支名称":"make sure this is the branch you are using"}
      - main

permissions:
  contents: write

jobs:
  deploy-gh-pages:
    runs-on: ubuntu-latest
    steps:
      - name: Checkout
        uses: actions/checkout@v4
        with:
          fetch-depth: 0
          # ${s==="zh"?"如果你文档需要 Git 子模块，取消注释下一行":"if your docs needs submodules, uncomment the following line"}
          # submodules: true

${e==="pnpm"?`      - name: ${s==="zh"?"安装 pnpm":"Install pnpm"}
        uses: pnpm/action-setup@v4
`:""}

      - name: ${s==="zh"?"设置 Node.js":"Setup Node.js"}
        uses: actions/setup-node@v4
        with:
          node-version: 22
          cache: ${e}

      - name: ${s==="zh"?"安装依赖":"Install Deps"}
        run: ${e==="npm"?"npm ci":`${e} install --frozen-lockfile`}

      - name: ${s==="zh"?"构建文档":"Build Docs"}
        env:
          NODE_OPTIONS: --max_old_space_size=8192
        run: |-
          ${e} run docs:build
          > docs/.vuepress/dist/.nojekyll

      - name: ${s==="zh"?"部署文档":"Deploy Docs"}
        uses: JamesIves/github-pages-deploy-action@v4
        with:
          # ${s==="zh"?"这是文档部署到的分支名称":"This is the branch where the docs are deployed to"}
          branch: gh-pages
          folder: docs/.vuepress/dist
`,Q=async({targetDirPath:e,packageManager:s,lang:t,locale:o,preset:i,bundler:r})=>{const n=await z({message:o.question.workflow,default:!0});console.info(o.flow.generateTemplate),_(u(L,i),u(e,"docs"));const c=u(e,"docs/.vuepress/config.js"),a=k(c,{encoding:"utf-8"});if(h(c,a.replace(/\n\nexport default defineUserConfig\(\{/,`
import { ${r}Bundler } from '@vuepress/bundler-${r}'

export default defineUserConfig({`).replace(/\}\)\n$/,`
  bundler: ${r}Bundler(),
})
`),{encoding:"utf-8"}),n){const l=u(e,".github/workflows");f(l),h(u(l,"deploy-docs.yml"),K(s,t),{encoding:"utf-8"})}},X={flow:{getVersion:"Getting latest version of deps...",createPackage:"Generating package.json...",generateTemplate:"Generating Template...",install:"Installing Deps...",devServer:`Staring dev server...
After the dev server starts running, please visit the given server link ('localhost:8080' by default)`},question:{i18n:"Does the project need multiple languages?",workflow:"Do you need a GitHub workflow to deploy docs on GitHub pages?",bundler:"Which bundler do you want to use?",preset:"What type of project do you want to create?",packageManager:"Choose package manager",devServer:"Would you like to preview template now?",name:"Your project name",version:"Your project version",description:"Your project description",license:"Your project license"},hint:{install:`This may take a few minutes, please be patient.
We can not correctly output progress bar from child process, so the process may look stuck.`,finish:"Successful Generated!",devServer:e=>`Hint: You should execute "${e} run docs:dev" to start dev server.`},error:{name:"package name should only contain lowercase characters, numbers and dash",version:"This version is not a valid one. Version should be like 'x.x.x'",bundler:'bundler (--bundler) only support "vite" or "webpack"',preset:'preset (--preset) only support "doc" or "blog"',theme:"Current theme is not supported yet, using @vuepress/theme-default instead.",dirMissing:e=>`You should specific a folder name for your project, e.g.: "my-blog", "my-docs"
For example: "${e} init vuepress my-docs"`,dirNotEmpty:e=>`Target folder "${e}" is not empty, please choose an empty folder or delete files in it.`}},Z={flow:{getVersion:"获取依赖的最新版本...",createPackage:"生成 package.json...",generateTemplate:"生成模板...",install:"安装依赖...",devServer:`启动开发服务器...
启动成功后，请在浏览器输入给出的开发服务器地址(默认为 'localhost:8080')`},question:{packageManager:"选择包管理器",i18n:"项目需要用到多语言么?",workflow:"是否需要一个自动部署文档到 GitHub Pages 的工作流？",bundler:"你想要使用哪个打包器？",preset:"你想要创建什么类型的项目？",devServer:"是否想要现在启动 Demo 查看?",name:"设置应用名称",version:"设置应用版本号",description:"设置应用描述",license:"设置协议"},hint:{install:`这可能需要数分钟，请耐心等待.
我们无法正确输出子进程的进度条，所以进程可能会看似未响应`,finish:"模板已成功生成!",devServer:e=>`提示: 请使用 "${e} run docs:dev" 命令启动开发服务器`},error:{name:"应用名称应只包含小写字母、数字和连接线 (-)",version:"此版本无效，版本号应为 'x.x.x'",bundler:"打包器 (--bundler) 仅支持 vite 或 webpack",preset:"预设 (--preset) 仅支持 doc 或 blog",theme:"当前主题暂不支持，将使用 @vuepress/theme-default 代替",dirMissing:e=>`你应该指定一个项目文件夹名称，例如 "my-blog", "my-docs"。
例如: "${e} init vuepress my-docs"`,dirNotEmpty:e=>`目标文件夹 "${e}" 不为空，请选择一个空文件夹或者手动删除文件夹中的文件`}},ee={en:X,zh:Z},se=async()=>{const e=await g({message:"Select a language to display / 选择显示语言",choices:[{name:"english (US)",value:"en"},{name:"简体中文",value:"zh"}]});return{lang:e,locale:ee[e]}},te=["vite","webpack"],re=["blog","docs"];async function oe(e,{bundler:s,preset:t,theme:o="@vuepress/theme-default"}){const{lang:i,locale:r}=await se(),n=await A(r.question.packageManager),c=Y(o);if(T[c]){d(`${n} ${T[c]} ${e}`,{stdio:"inherit"});return}o!=="@vuepress/theme-default"&&console.warn(r.error.theme),s&&!["vite","webpack"].includes(s)&&this.error(r.error.bundler),t&&!["docs","blog"].includes(t)&&this.error(r.error.preset),(!e||e.startsWith("[")&&e.endsWith("]"))&&this.error(r.error.dirMissing(n));const a=E(process.cwd(),e);W(a)&&w(a).length&&this.error(r.error.dirNotEmpty(e)),f(a),s||(s=await g({message:r.question.bundler,choices:te.map(p=>({name:p,value:p}))})),t||(t=await g({message:r.question.preset,choices:re.map(p=>({name:p,value:p}))})),await B({targetDir:e,packageManager:n,locale:r,preset:t,bundler:s}),await Q({targetDirPath:a,packageManager:n,lang:i,locale:r,preset:t,bundler:s});const l=n==="pnpm"?"":await I(n,i);console.log(r.flow.install),console.warn(r.hint.install),d(`${n} install ${l?`--registry ${l}`:""}`,{cwd:a,stdout:"inherit"}),console.log(r.hint.finish),await z({message:r.question.devServer,default:!0})?(console.log(r.flow.devServer),await G(`${n} run docs:dev`,{cwd:e,stdout:"inherit"})):console.log(r.hint.devServer(n))}const b=q("create-vuepress");b.argument("<dir>","Dir to create the template in").option("-t, --theme [theme]","Theme to use").option("-p, --preset [preset]","Preset to use, docs or blog only").description(`Generate a new vuepress template

· pnpm create vuepress <dir>
· npm init vuepress@latest <dir>
· yarn create vuepress <dir>
`).action(oe),b.version(R),b.showHelpAfterError("add --help for additional information"),await b.parseAsync();
//# sourceMappingURL=index.js.map
